#include "ircbot.h"
#include "basemodule.h"
#include "message.h"

IRCBot::IRCBot(QString nick_, QString chan_) : nick(nick_), chan(chan_)
{
    addModule(new BaseModule());
}

void IRCBot::receiveMsg(QString str)
{
    Message msg = Message(str);

    for(Module* m : modules)
    {
        if(m->isEnabled() && m->messageHandler(msg))
            emit sendMsg(m->getAnswer());
    }
}

QString IRCBot::getChan()
{
    return chan;
}

void IRCBot::addModule(Module* module)
{
    modules.push_back(module);
    module->setChan(chan);
    module->setNick(nick);
    module->setModuleList(&modules);
}

void IRCBot::disconnect()
{
    emit sendMsg("QUIT :\r\n");
}
