#ifndef IRCBOT_H
#define IRCBOT_H

#include <QObject>
#include <vector>


class Module;
class BaseModule;

class IRCBot : public QObject
{
    Q_OBJECT

    QString nick;
    QString chan;

    std::vector<Module*> modules;
    BaseModule *base;
public:
    IRCBot(QString nick_, QString chan_);

public:
    void addModule(Module* module);
    BaseModule* getBaseModule();
    QString getChan();

public slots:
    void receiveMsg(QString msg);
    void disconnect();

signals:
    void sendMsg(QString msg);
};

#endif // IRCBOT_H
