#include "module.h"
#include "user.h"
#include "basemodule.h"

QString Module::getAnswer()
{
    return answer;
}

bool Module::isEnabled()
{
   return enabled;
}

void Module::setEnabled(bool newStatus)
{
    enabled = newStatus;
}

QString Module::getNick()
{
    return nick;
}

QString Module::getChan()
{
    return chan;
}

int Module::getNbModules()
{
    if(modules == NULL)
        return 0;
    return modules->size();
}

UserList* Module::getUsers()
{
    if(modules == NULL)
        return NULL;
    BaseModule* base = (BaseModule*)(modules->at(0));
    return base->getUserList();
}

Module* Module::getModule(int index)
{
    if(modules == NULL)
        return NULL;
    return modules->at(index);
}

void Module::setNick(QString nick_)
{
    nick = nick_;
}

void Module::setChan(QString chan_)
{
    chan = chan_;
}

void Module::setModuleList(std::vector<Module*>* modList)
{
    modules = modList;
}

// IRC COMMANDS

QString Module::pong(QString target)
{
    return QString("PONG :%1\r\n").arg(target);
}

QString Module::join(QString theChan)
{
    return QString("JOIN #%1\r\n").arg(theChan);
}

QString Module::whois(QString nick)
{
    return QString("WHOIS %1\r\n").arg(nick);
}

QString Module::say(QString str)
{
    return QString("PRIVMSG #%1 :%2\r\n").arg(chan).arg(str);
}

QString Module::privateSay(QString str, QString target)
{
    return QString("PRIVMSG %1 :%2\r\n").arg(target).arg(str);
}

QString Module::action(QString str)
{
    return QString("PRIVMSG #%1 :\001ACTION %2\001\r\n").arg(chan).arg(str);
}

QString Module::quit(QString str)
{
    return QString("QUIT :%1\r\n").arg(str);
}
